INSERT INTO [Account] ([Name])
SELECT
    t.Name
FROM
    (SELECT @AccountName AS Name) t
    LEFT OUTER JOIN Account a ON a.Name = t.Name
WHERE
    t.Name IS NOT NULL
    AND a.Name IS NULL;
GO

INSERT INTO [Item] ([Name])
SELECT
    t.Name
FROM
    (SELECT @ItemName AS Name) t
    LEFT OUTER JOIN Item a ON a.Name = t.Name
WHERE
    t.Name IS NOT NULL
    AND a.Name IS NULL;
GO

INSERT INTO [Company] ([Name])
SELECT
    t.Name
FROM
    (SELECT @CompanyName AS Name) t
    LEFT OUTER JOIN Company a ON a.Name = t.Name
WHERE
    t.Name IS NOT NULL
    AND a.Name IS NULL;
GO

INSERT INTO Payment
    ([Date]
    ,[Sum]
    ,[AccountID]
    ,[CompanyID]
    ,[ItemID]
    ,[Comment])
SELECT
    @Date AS [Date]
    , @Sum AS [Sum]
    , a.ID AS AccountID
    , c.ID AS CompanyID
    , i.ID AS ItemID
    , @Comment AS Comment
FROM
    (SELECT MIN(ID) AS ID FROM Account WHERE Name = @AccountName) a
    , (SELECT MIN(ID) AS ID FROM Company WHERE Name = @CompanyName) c
    , (SELECT MIN(ID) AS ID FROM Item WHERE Name = @ItemName) i;
GO
