-- DDE Interactive Brokers Install Code
-- July 15, 2014

-- This SQL code must be executed after SaveToDB Framework installation!

CREATE TABLE [WatchList] (
    [ID] int NOT NULL IDENTITY,
    [WatchList] nvarchar(50), 
    [Symbol] nvarchar(25), 
    [RangeHigh] float, 
    [RangeLow] float, 
    [VolumeAvg] int, 
    [Comment] nvarchar(1000),
    CONSTRAINT [PK_WatchList] PRIMARY KEY ([ID])
);
GO

--INSERT INTO [WatchList] ([WatchList],[Symbol],[RangeHigh],[RangeLow],[VolumeAvg],[Comment]) VALUES ('Stocks','AAPL',450,400,15000000,NULL);
--GO
--INSERT INTO [WatchList] ([WatchList],[Symbol],[RangeHigh],[RangeLow],[VolumeAvg],[Comment]) VALUES ('Stocks','MSFT',35,32,50000000,NULL);
--GO
--INSERT INTO [WatchList] ([WatchList],[Symbol],[RangeHigh],[RangeLow],[VolumeAvg],[Comment]) VALUES ('Stocks','GOOG',900,870,2300000,NULL);
--GO
--INSERT INTO [WatchList] ([WatchList],[Symbol],[RangeHigh],[RangeLow],[VolumeAvg],[Comment]) VALUES ('Stocks','ORCL',34,30,27000000,NULL);
--GO

INSERT INTO [QueryList] ([TABLE_SCHEMA],[TABLE_NAME],[TABLE_TYPE],[INSERT_PROCEDURE],[UPDATE_PROCEDURE],[DELETE_PROCEDURE]) VALUES ('SELECT
    ID
    , WatchList
    , Symbol
    , CASE WHEN @UserName IS NULL THEN NULL ELSE ''=S'' + @UserName + ''|tik!id'' + CAST(ID AS nvarchar) + ''?last'' END AS Last
    , CASE WHEN @UserName IS NULL THEN NULL ELSE ''=S'' + @UserName + ''|tik!id'' + CAST(ID AS nvarchar) + ''?high'' END AS High
    , CASE WHEN @UserName IS NULL THEN NULL ELSE ''=S'' + @UserName + ''|tik!id'' + CAST(ID AS nvarchar) + ''?low'' END AS Low
    , RangeHigh
    , RangeLow
    , VolumeAvg
    , CASE WHEN @UserName IS NULL THEN NULL ELSE ''=S'' + @UserName + ''|tik!id'' + CAST(ID AS nvarchar) + ''?volume*100'' END AS Volume
    , Comment
    , @UserName AS UserName
    , CASE WHEN @UserName IS NULL THEN NULL ELSE ''=S'' + @UserName + ''|tik!id'' + CAST(ID AS nvarchar) + ''?req?'' + Symbol + ''_STK_SMART_USD'' END AS Ctrl
FROM
    WatchList AS w
WHERE
    Symbol IS NOT NULL
    AND (@WatchList IS NULL OR @WatchList = WatchList)','WatchList DDE','CODE','WatchList','WatchList','WatchList');
GO

INSERT INTO [EventHandlers] ([TABLE_SCHEMA],[TABLE_NAME],[COLUMN_NAME],[EVENT_NAME],[HANDLER_SCHEMA],[HANDLER_NAME],[HANDLER_TYPE],[TARGET_WORKSHEET],[MENU_ORDER],[EDIT_PARAMETERS]) VALUES (NULL,'WatchList DDE',NULL,'ContextMenu','http://www.google.com/finance?q={Symbol}','Google Finance {Symbol}','HTTP',NULL,11,NULL);
GO
INSERT INTO [EventHandlers] ([TABLE_SCHEMA],[TABLE_NAME],[COLUMN_NAME],[EVENT_NAME],[HANDLER_SCHEMA],[HANDLER_NAME],[HANDLER_TYPE],[TARGET_WORKSHEET],[MENU_ORDER],[EDIT_PARAMETERS]) VALUES (NULL,'WatchList DDE',NULL,'ContextMenu','http://finance.yahoo.com/q?s={Symbol}','Yahoo Finance {Symbol}','HTTP',NULL,12,NULL);
GO

INSERT INTO [ObjectTranslation] ([TABLE_SCHEMA],[TABLE_NAME],[LANGUAGE_NAME],[TRANSLATED_NAME],[TRANSLATED_DESC],[TRANSLATED_COMMENT]) VALUES (NULL,'WatchList','en',NULL,'WatchList Table','The table contains WatchList data. Use Publish Wizard to change the table design.');
GO
INSERT INTO [ObjectTranslation] ([TABLE_SCHEMA],[TABLE_NAME],[LANGUAGE_NAME],[TRANSLATED_NAME],[TRANSLATED_DESC],[TRANSLATED_COMMENT]) VALUES (NULL,'WatchList DDE','en',NULL,'WatchList View','The view selects data from the WatchList table and defines DDE formulas. The data can be saved back to the WatchList table.');
GO

INSERT INTO [TableFormats] ([TABLE_SCHEMA],[TABLE_NAME],[TABLE_EXCEL_FORMAT_XML]) VALUES (NULL,'WatchList DDE','<?xml version="1.0" encoding="Unicode"?>
<table name="WatchList DDE">
<columnFormats>
<column name="" property="ListObjectName" value="WatchList_DDE_Table1" type="String" />
<column name="" property="ShowTotals" value="False" type="Boolean" />
<column name="" property="TableStyle.Name" value="TableStyleMedium15" type="String" />
<column name="" property="ShowTableStyleColumnStripes" value="False" type="Boolean" />
<column name="" property="ShowTableStyleFirstColumn" value="False" type="Boolean" />
<column name="" property="ShowShowTableStyleLastColumn" value="False" type="Boolean" />
<column name="" property="ShowTableStyleRowStripes" value="False" type="Boolean" />
<column name="_RowNum" property="EntireColumn.Hidden" value="True" type="Boolean" />
<column name="_RowNum" property="Address" value="$B$5" type="String" />
<column name="ID" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="ID" property="Address" value="$C$5" type="String" />
<column name="ID" property="ColumnWidth" value="4.43" type="Double" />
<column name="ID" property="Interior.Pattern" value="1" type="Double" />
<column name="ID" property="Interior.PatternColorIndex" value="-4105" type="Double" />
<column name="ID" property="Interior.ThemeColor" value="1" type="Double" />
<column name="ID" property="Interior.TintAndShade" value="-0.149998474074526" type="Double" />
<column name="ID" property="Border10.LineStyle" value="1" type="Double" />
<column name="ID" property="Border10.ColorIndex" value="-4105" type="Double" />
<column name="ID" property="Border10.Weight" value="-4138" type="Double" />
<column name="WatchList" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="WatchList" property="Address" value="$D$5" type="String" />
<column name="WatchList" property="ColumnWidth" value="6.43" type="Double" />
<column name="WatchList" property="Interior.Pattern" value="1" type="Double" />
<column name="WatchList" property="Interior.PatternColorIndex" value="-4105" type="Double" />
<column name="WatchList" property="Interior.ThemeColor" value="1" type="Double" />
<column name="WatchList" property="Interior.TintAndShade" value="-0.0499893185216834" type="Double" />
<column name="WatchList" property="Border7.LineStyle" value="1" type="Double" />
<column name="WatchList" property="Border7.ColorIndex" value="-4105" type="Double" />
<column name="WatchList" property="Border7.Weight" value="-4138" type="Double" />
<column name="Symbol" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="Symbol" property="Address" value="$E$5" type="String" />
<column name="Symbol" property="ColumnWidth" value="6.71" type="Double" />
<column name="Symbol" property="Interior.Pattern" value="1" type="Double" />
<column name="Symbol" property="Interior.PatternColorIndex" value="-4105" type="Double" />
<column name="Symbol" property="Interior.ThemeColor" value="1" type="Double" />
<column name="Symbol" property="Interior.TintAndShade" value="-0.0499893185216834" type="Double" />
<column name="Symbol" property="Border10.LineStyle" value="1" type="Double" />
<column name="Symbol" property="Border10.ColorIndex" value="-4105" type="Double" />
<column name="Symbol" property="Border10.Weight" value="-4138" type="Double" />
<column name="Last" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="Last" property="Address" value="$F$5" type="String" />
<column name="Last" property="ColumnWidth" value="7.57" type="Double" />
<column name="Last" property="NumberFormat" value="0.00" type="String" />
<column name="Last" property="Border7.LineStyle" value="1" type="Double" />
<column name="Last" property="Border7.ColorIndex" value="-4105" type="Double" />
<column name="Last" property="Border7.Weight" value="-4138" type="Double" />
<column name="High" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="High" property="Address" value="$G$5" type="String" />
<column name="High" property="ColumnWidth" value="8.43" type="Double" />
<column name="High" property="NumberFormat" value="0.00" type="String" />
<column name="Low" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="Low" property="Address" value="$H$5" type="String" />
<column name="Low" property="ColumnWidth" value="8.43" type="Double" />
<column name="Low" property="NumberFormat" value="0.00" type="String" />
<column name="RangeHigh" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="RangeHigh" property="Address" value="$I$5" type="String" />
<column name="RangeHigh" property="ColumnWidth" value="6.71" type="Double" />
<column name="RangeHigh" property="NumberFormat" value="0.00" type="String" />
<column name="RangeHigh" property="Interior.Pattern" value="1" type="Double" />
<column name="RangeHigh" property="Interior.PatternColorIndex" value="-4105" type="Double" />
<column name="RangeHigh" property="Interior.ThemeColor" value="1" type="Double" />
<column name="RangeHigh" property="Interior.TintAndShade" value="-0.0499893185216834" type="Double" />
<column name="RangeLow" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="RangeLow" property="Address" value="$J$5" type="String" />
<column name="RangeLow" property="ColumnWidth" value="7.57" type="Double" />
<column name="RangeLow" property="NumberFormat" value="0.00" type="String" />
<column name="RangeLow" property="Interior.Pattern" value="1" type="Double" />
<column name="RangeLow" property="Interior.PatternColorIndex" value="-4105" type="Double" />
<column name="RangeLow" property="Interior.ThemeColor" value="1" type="Double" />
<column name="RangeLow" property="Interior.TintAndShade" value="-0.0499893185216834" type="Double" />
<column name="RangeLow" property="Border10.LineStyle" value="1" type="Double" />
<column name="RangeLow" property="Border10.ColorIndex" value="-4105" type="Double" />
<column name="RangeLow" property="Border10.Weight" value="-4138" type="Double" />
<column name="VolumeAvg" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="VolumeAvg" property="Address" value="$K$5" type="String" />
<column name="VolumeAvg" property="ColumnWidth" value="9.86" type="Double" />
<column name="VolumeAvg" property="NumberFormat" value="#,##0" type="String" />
<column name="VolumeAvg" property="Interior.Pattern" value="1" type="Double" />
<column name="VolumeAvg" property="Interior.PatternColorIndex" value="-4105" type="Double" />
<column name="VolumeAvg" property="Interior.ThemeColor" value="1" type="Double" />
<column name="VolumeAvg" property="Interior.TintAndShade" value="-0.0499893185216834" type="Double" />
<column name="VolumeAvg" property="Border7.LineStyle" value="1" type="Double" />
<column name="VolumeAvg" property="Border7.ColorIndex" value="-4105" type="Double" />
<column name="VolumeAvg" property="Border7.Weight" value="-4138" type="Double" />
<column name="Volume" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="Volume" property="Address" value="$L$5" type="String" />
<column name="Volume" property="ColumnWidth" value="10" type="Double" />
<column name="Volume" property="NumberFormat" value="#,##0" type="String" />
<column name="Volume,%" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="Volume,%" property="Address" value="$M$5" type="String" />
<column name="Volume,%" property="FormulaR1C1" value="=IF([@VolumeAvg]=0,0,[@Volume]/[@VolumeAvg])" type="String" />
<column name="Volume,%" property="ColumnWidth" value="7.43" type="Double" />
<column name="Volume,%" property="NumberFormat" value="0%;-0%;" type="String" />
<column name="Volume,%" property="Border10.LineStyle" value="1" type="Double" />
<column name="Volume,%" property="Border10.ColorIndex" value="-4105" type="Double" />
<column name="Volume,%" property="Border10.Weight" value="-4138" type="Double" />
<column name="PriceMark" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="PriceMark" property="Address" value="$N$5" type="String" />
<column name="PriceMark" property="FormulaR1C1" value="=IF([@RangeHigh]=0,&#34;&#34;,IF([@Last]&#62;[@RangeHigh],1,IF([@Last]&#60;[@RangeLow],-1,0)))" type="String" />
<column name="PriceMark" property="ColumnWidth" value="2" type="Double" />
<column name="PriceMark" property="NumberFormat" value="0.0%" type="String" />
<column name="PriceMark" property="HorizontalAlignment" value="-4108" type="Double" />
<column name="PriceMark" property="Font.Size" value="10" type="Double" />
<column name="PriceMark" property="Border7.LineStyle" value="1" type="Double" />
<column name="PriceMark" property="Border7.ColorIndex" value="-4105" type="Double" />
<column name="PriceMark" property="Border7.Weight" value="-4138" type="Double" />
<column name="VolumeMark" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="VolumeMark" property="Address" value="$O$5" type="String" />
<column name="VolumeMark" property="FormulaR1C1" value="=IF([@VolumeAvg]=0,&#34;&#34;,IF([@Volume]&#62;[@VolumeAvg]*R1C13,1,IF([@Volume]&#60;[@VolumeAvg]*R1C13*0.5,-1,0)))" type="String" />
<column name="VolumeMark" property="ColumnWidth" value="2" type="Double" />
<column name="VolumeMark" property="NumberFormat" value="0.0%" type="String" />
<column name="VolumeMark" property="HorizontalAlignment" value="-4108" type="Double" />
<column name="VolumeMark" property="Font.Size" value="10" type="Double" />
<column name="VolumeMark" property="Border10.LineStyle" value="1" type="Double" />
<column name="VolumeMark" property="Border10.ColorIndex" value="-4105" type="Double" />
<column name="VolumeMark" property="Border10.Weight" value="-4138" type="Double" />
<column name="Comment" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="Comment" property="Address" value="$P$5" type="String" />
<column name="Comment" property="ColumnWidth" value="19.71" type="Double" />
<column name="Comment" property="Border7.LineStyle" value="1" type="Double" />
<column name="Comment" property="Border7.ColorIndex" value="-4105" type="Double" />
<column name="Comment" property="Border7.Weight" value="-4138" type="Double" />
<column name="UserName" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="UserName" property="Address" value="$Q$5" type="String" />
<column name="UserName" property="ColumnWidth" value="11.86" type="Double" />
<column name="Ctrl" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="Ctrl" property="Address" value="$R$5" type="String" />
<column name="Ctrl" property="ColumnWidth" value="5.71" type="Double" />
<column name="Last" property="FormatConditions(1).AppliesTo.Address" value="$F$5:$F$8" type="String" />
<column name="Last" property="FormatConditions(1).Type" value="2" type="Double" />
<column name="Last" property="FormatConditions(1).Priority" value="1" type="Double" />
<column name="Last" property="FormatConditions(1).Formula1" value="=($F5&#60;$J5)" type="String" />
<column name="Last" property="FormatConditions(1).NumberFormat" value="General" type="String" />
<column name="Last" property="FormatConditions(1).Interior.Color" value="9420794" type="Double" />
<column name="Last" property="FormatConditions(1).Interior.PatternThemeColor" value="-1" type="Double" />
<column name="Last" property="FormatConditions(1).Interior.ThemeColor" value="10" type="Double" />
<column name="Last" property="FormatConditions(1).Interior.TintAndShade" value="0.399945066682943" type="Double" />
<column name="Last" property="FormatConditions(2).AppliesTo.Address" value="$F$5:$F$8" type="String" />
<column name="Last" property="FormatConditions(2).Type" value="2" type="Double" />
<column name="Last" property="FormatConditions(2).Priority" value="2" type="Double" />
<column name="Last" property="FormatConditions(2).Formula1" value="=($F5&#62;$I5)" type="String" />
<column name="Last" property="FormatConditions(2).NumberFormat" value="General" type="String" />
<column name="Last" property="FormatConditions(2).Interior.Color" value="5296274" type="Double" />
<column name="Last" property="FormatConditions(2).Interior.PatternThemeColor" value="-1" type="Double" />
<column name="Volume,%" property="FormatConditions(1).AppliesTo.Address" value="$M$5:$M$8" type="String" />
<column name="Volume,%" property="FormatConditions(1).Type" value="2" type="Double" />
<column name="Volume,%" property="FormatConditions(1).Priority" value="3" type="Double" />
<column name="Volume,%" property="FormatConditions(1).Formula1" value="=M5&#62;$M$1" type="String" />
<column name="Volume,%" property="FormatConditions(1).NumberFormat" value="General" type="String" />
<column name="Volume,%" property="FormatConditions(1).Interior.Color" value="5296274" type="Double" />
<column name="Volume,%" property="FormatConditions(1).Interior.PatternThemeColor" value="-1" type="Double" />
<column name="PriceMark" property="FormatConditions(1).AppliesTo.Address" value="$N$5:$N$8" type="String" />
<column name="PriceMark" property="FormatConditions(1).Type" value="6" type="Double" />
<column name="PriceMark" property="FormatConditions(1).Priority" value="5" type="Double" />
<column name="PriceMark" property="FormatConditions(1).ShowIconOnly" value="True" type="Boolean" />
<column name="PriceMark" property="FormatConditions(1).IconSet.ID" value="4" type="Double" />
<column name="PriceMark" property="FormatConditions(1).IconCriteria(1).Type" value="3" type="Double" />
<column name="PriceMark" property="FormatConditions(1).IconCriteria(1).Operator" value="7" type="Double" />
<column name="PriceMark" property="FormatConditions(1).IconCriteria(2).Operator" value="7" type="Double" />
<column name="PriceMark" property="FormatConditions(1).IconCriteria(3).Value" value="1" type="Double" />
<column name="PriceMark" property="FormatConditions(1).IconCriteria(3).Operator" value="7" type="Double" />
<column name="VolumeMark" property="FormatConditions(1).AppliesTo.Address" value="$O$5:$O$8" type="String" />
<column name="VolumeMark" property="FormatConditions(1).Type" value="6" type="Double" />
<column name="VolumeMark" property="FormatConditions(1).Priority" value="4" type="Double" />
<column name="VolumeMark" property="FormatConditions(1).ShowIconOnly" value="True" type="Boolean" />
<column name="VolumeMark" property="FormatConditions(1).IconSet.ID" value="4" type="Double" />
<column name="VolumeMark" property="FormatConditions(1).IconCriteria(1).Type" value="3" type="Double" />
<column name="VolumeMark" property="FormatConditions(1).IconCriteria(1).Operator" value="7" type="Double" />
<column name="VolumeMark" property="FormatConditions(1).IconCriteria(2).Operator" value="7" type="Double" />
<column name="VolumeMark" property="FormatConditions(1).IconCriteria(3).Value" value="1" type="Double" />
<column name="VolumeMark" property="FormatConditions(1).IconCriteria(3).Operator" value="7" type="Double" />
<column name="" property="ActiveWindow.DisplayGridlines" value="False" type="Boolean" />
<column name="" property="ActiveWindow.FreezePanes" value="True" type="Boolean" />
<column name="" property="ActiveWindow.Split" value="True" type="Boolean" />
<column name="" property="ActiveWindow.SplitRow" value="0" type="Double" />
<column name="" property="ActiveWindow.SplitColumn" value="-2" type="Double" />
<column name="" property="PageSetup.Orientation" value="1" type="Double" />
<column name="" property="PageSetup.Zoom" value="100" type="Double" />
</columnFormats>
</table>
');
GO

INSERT INTO [TableFormats] ([TABLE_SCHEMA],[TABLE_NAME],[TABLE_EXCEL_FORMAT_XML]) VALUES (NULL,'WatchList','<?xml version="1.0" encoding="Unicode"?>
<table name="WatchList">
<columnFormats>
<column name="" property="ListObjectName" value="Sheet2_Table1" type="String" />
<column name="" property="ShowTotals" value="False" type="Boolean" />
<column name="" property="TableStyle.Name" value="TableStyleMedium15" type="String" />
<column name="" property="ShowTableStyleColumnStripes" value="False" type="Boolean" />
<column name="" property="ShowTableStyleFirstColumn" value="False" type="Boolean" />
<column name="" property="ShowShowTableStyleLastColumn" value="False" type="Boolean" />
<column name="" property="ShowTableStyleRowStripes" value="False" type="Boolean" />
<column name="_RowNum" property="EntireColumn.Hidden" value="True" type="Boolean" />
<column name="_RowNum" property="Address" value="$B$7" type="String" />
<column name="ID" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="ID" property="Address" value="$C$7" type="String" />
<column name="ID" property="ColumnWidth" value="4.43" type="Double" />
<column name="WatchList" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="WatchList" property="Address" value="$D$7" type="String" />
<column name="WatchList" property="ColumnWidth" value="11.29" type="Double" />
<column name="Symbol" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="Symbol" property="Address" value="$E$7" type="String" />
<column name="Symbol" property="ColumnWidth" value="9.14" type="Double" />
<column name="RangeHigh" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="RangeHigh" property="Address" value="$F$7" type="String" />
<column name="RangeHigh" property="ColumnWidth" value="12" type="Double" />
<column name="RangeLow" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="RangeLow" property="Address" value="$G$7" type="String" />
<column name="RangeLow" property="ColumnWidth" value="11.57" type="Double" />
<column name="VolumeAvg" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="VolumeAvg" property="Address" value="$H$7" type="String" />
<column name="VolumeAvg" property="ColumnWidth" value="12.86" type="Double" />
<column name="Comment" property="EntireColumn.Hidden" value="False" type="Boolean" />
<column name="Comment" property="Address" value="$I$7" type="String" />
<column name="Comment" property="ColumnWidth" value="11.29" type="Double" />
<column name="" property="ActiveWindow.DisplayGridlines" value="False" type="Boolean" />
<column name="" property="ActiveWindow.FreezePanes" value="True" type="Boolean" />
<column name="" property="ActiveWindow.Split" value="True" type="Boolean" />
<column name="" property="ActiveWindow.SplitRow" value="0" type="Double" />
<column name="" property="ActiveWindow.SplitColumn" value="-2" type="Double" />
<column name="" property="PageSetup.Orientation" value="1" type="Double" />
<column name="" property="PageSetup.Zoom" value="100" type="Double" />
</columnFormats>
</table>
');
GO

-- print The DDE Interactive Brokers example has been installed
